unit uIA_Keys_IO;

interface

uses
  Trpcb,
  Contnrs,
  uIA_Instrument;


function ReadScoringKeys(Broker: TRPCBroker; var aInstrument: TInstrument): Boolean;

implementation

uses
  uIA_Key,
  uIA_Utils,
  uIA_Const;


function ReadAllKeysInVista(WhichInstrument: string; Broker: TRPCBroker): string;
var
  i                           : integer;
begin
  Result := '';

  with Broker do
    begin
      ClearParameters := True;
      ClearResults := True;
      CreateContext('YS BROKER1');
      RemoteProcedure := 'YTQ KEYS';
      Param[0].Mult['"CODE"'] := WhichInstrument;
      Param[0].PType := List;

      Call;

      if Results[0] = DATA then
        begin
          for i := 1 to Results.Count - 1 do
            Result := Result + Results[i] + RECORD_END;

          Result := DropTrailer(Result);
        end;

      // No keys for this instrument
      if Results[0] = '[ERROR]' then
        if Results.Count > 0 then
          if Results[1] = 'no scale grps found' then
            Result := '';
      // Needed for DLL, in case there is a crash
      CreateContext('OR CPRS GUI CHART');
    end;
end;


function ReadScoringKeys(Broker: TRPCBroker; var aInstrument: TInstrument): Boolean;
var
  tmpAllKeys,
    tmpRecord,
    tmpKey,
    tmpScaleID
                              : string;
  i                           : integer;
  AKey                        : TKey;

  //[DATA]
  //SCALE=Score^100088^
  //KEY=3821^Some or a little of the time (1-2 days)^1^100010
  //KEY=3821^Occasionally or a moderate amount of time (3-4 days)^2^100011
  //KEY=3821^Most or all of the time (5-7 days)^3^100012

begin
  Result := True;

  tmpAllKeys := ReadAllKeysInVista(aInstrument.InstrumentName, Broker);

  // No keys for this instrument
  if (tmpAllKeys = '') then
    Exit;

  if (tmpAllKeys = BAD_DATA) then
    begin
      Result := False;
      Exit;
    end;

  tmpRecord := Piece(tmpAllKeys, RECORD_END, 1);
  tmpScaleID := Piece(Piece(tmpRecord, EQ, 2), U, 2);

  for i := 1 to NumberOfPieces(tmpAllKeys, RECORD_END) do
    begin
      tmpRecord := Piece(tmpAllKeys, RECORD_END, i);

      if (pos('SCALE', tmpRecord) > 0) then
        begin
          tmpScaleID := Piece(Piece(tmpRecord, EQ, 2), U, 2);
        end //is a new scale
      else
        begin
          AKey := TKey.Create;
          tmpKey := Piece(tmpRecord, EQ, 2);
          AKey.ScaleID := tmpScaleID;
          AKey.QuestionID := Piece(tmpKey, U, 1);
          AKey.AnswerText := Piece(tmpKey, U, 2);
          AKey.Value := Piece(tmpKey, U, 3);
          AKey.IEN := Piece(tmpKey, U, 4);
          aInstrument.ListOfKeys.Add(AKey);
        end;
    end; // for i
end;

end.

