unit uIA_Rule;

interface

uses
  Classes,
  SysUtils;

type
  TBoolOperatorType = (boAND, boOR);
  TValueDataType = (dtString, dtDate, dtNumber, dtTimeInterval);
  TOperatorType = (toEQ, toLT, toLE, toGT, toGE, toNE);

type
  TRule = class
    FirstValueDataType,
      SecondValueDataType: TValueDataType;
    FirstOperator,
      SecondOperator: TOperatorType;
    BoolOperator: TBoolOperatorType;

  private
    FID,
      FFirstQuestionID,
      FSecondQuestionID,
      FFirstValue,
      FSecondValue,
      FMessageText,
      FSkipQuestionIDs: string;
  protected
  public
    //destructor Destroy;
    constructor Create;
    property ID: string read FID write FID;
    property FirstQuestionID: string read FFirstQuestionID write FFirstQuestionID;
    property SecondQuestionID: string read FSecondQuestionID write FSecondQuestionID;
    property FirstValue: string read FFirstValue write FFirstValue;
    property SecondValue: string read FSecondValue write FSecondValue;
    property MessageText: string read FMessageText write FMessageText;
    property SkipQuestionIDs: string read FSkipQuestionIDs write FSkipQuestionIDs;
    // Series of QuestionIDs with ^ as delimiter

    procedure Clear;
  published
  end; { TRule }


implementation

procedure TRule.Clear;
begin
  FID := '';
  FFirstQuestionID := '';
  FirstValueDataType := dtString;
  FirstOperator := toEQ;
  FFirstValue := '';
  BoolOperator := boAND;
  FSecondQuestionID := '';
  SecondOperator := toEQ;
  SecondValueDataType := dtString;
  FSecondValue := '';
  FMessageText := '';
end;


constructor TRule.Create;
begin
  inherited Create;
  Clear;
end;

//destructor TRule.Destroy;
//begin
//  inherited Destroy;
//end;


end.

