unit uMHA_DLL_Answer_IO;

interface

procedure AdministrationWriteUpdatedProperties;

implementation

uses
  uIA_Const,
  uMHA_DLL_Const;


procedure AdministrationWriteUpdatedProperties;
begin

  case DataBaseMode of
    dbVista:
      begin
        with DataModule1.RPCBroker1 do
        begin
          ClearParameters := True;
          ClearResults := True;
          RemoteProcedure := 'YTQ SAVE';
          Param[0].Mult['"FILEN"'] := '601.84';
          Param[0].Mult['"IEN"'] := tmpID;

          //Do not resave DateGiven, which is the date/time of the first
          //time the administration was saved (see AdministrationWriteNew)
          //Param[0].Mult['"4"'] := '3^NOW';
          //DateSaved, on the other hand, is updated with every answer saved,
          //which calls this method
          Param[0].Mult['"4"'] := '4^NOW'; //Administration.DateSaved
          Param[0].Mult['"5"'] := '5^' + tmpOrderedBy;
          Param[0].Mult['"6"'] := '6^' + tmpAdministeredBy;
          Param[0].Mult['"7"'] := '7^' + tmpSigned;
          Param[0].Mult['"8"'] := '8^' + tmpIsComplete;
          Param[0].Mult['"9"'] := '9^' + tmpNumberOfQuestionsAnswered;
          Param[0].PType := List;
          Call;

        end;
      end; //case dbVista

    dbOffLine:
      begin
        tmpList := TStringList.Create;
        with tmpList do
        begin
          Clear;
          Add('AdministrationID=' + tmpID);
          Add('InstrumentName=' + Piece(AnAdministration, U, 7));
          //          Add('DateGiven=' + DateTimeToStr(DateGiven));
          Add('DateSaved=' + DateTimeToStr(Now));
          //          tmpList.Add('OrderedBy=' + OrderedBy);
          //          tmpList.Add('AdministeredBy=' + AdministeredBy);
          Add('Signed=' + tmpSigned);
          Add('IsComplete=' + tmpIsComplete);
          Add('NumberOfQuestionsAnswered=' + tmpNumberOfQuestionsAnswered);

          tmpDateGiven := StrToDateTime(Piece(AnAdministration, U, 8));
          LocalFiles.LoadAdministrationFileName(Piece(AnAdministration, U, 9),
            DateTimeToFileNameDateTime(tmpDateGiven),
            Piece(AnAdministration, U, 7));

          SaveToFile(LocalFiles.AdministrationFileName);

          Free;
        end; //with tmpList

      end;
  end; //case DataBaseMode
end;

end.
 